UPDATE table_version SET version_number = '6' WHERE version_id = '1';

ALTER TABLE table_user MODIFY user_enabled BOOL NOT NULL DEFAULT 1;

ALTER TABLE table_specification MODIFY specification_isFormal BOOL NOT NULL DEFAULT 0;

ALTER TABLE table_testcase_execution MODIFY testcase_execution_message MEDIUMTEXT NULL;

DROP TABLE table_defect;

CREATE TABLE table_defect_generic (
  defect_id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  folder_id INTEGER UNSIGNED NOT NULL,
  external_id INTEGER UNSIGNED NULL,
  PRIMARY KEY(defect_id),
  INDEX defect_FKIndex1(folder_id),
  FOREIGN KEY(folder_id)
    REFERENCES table_folder(folder_id)
      ON DELETE CASCADE
      ON UPDATE NO ACTION
)
ENGINE=InnoDB;

CREATE TABLE table_defect_integrated (
  defect_id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  folder_id INTEGER UNSIGNED NOT NULL,
  defect_name TEXT NULL,
  defect_description TEXT NULL,
  priority INTEGER NULL,
  severity INTEGER NULL,
  reporter INTEGER UNSIGNED NOT NULL,
  assigned_to INTEGER UNSIGNED NOT NULL,
  status TEXT NULL,
  PRIMARY KEY(defect_id),
  INDEX defect_FKIndex1(folder_id),
  INDEX defect_FKIndex2(reporter),
  INDEX defect_FKIndex3(assigned_to),
  FOREIGN KEY(folder_id)
    REFERENCES table_folder(folder_id)
      ON DELETE CASCADE
      ON UPDATE NO ACTION,
  FOREIGN KEY(reporter)
    REFERENCES table_user(user_id)
      ON DELETE CASCADE
      ON UPDATE NO ACTION,
  FOREIGN KEY(assigned_to)
    REFERENCES table_user(user_id)
      ON DELETE CASCADE
      ON UPDATE NO ACTION
)
ENGINE=InnoDB;