UPDATE table_version SET version_number = '48' WHERE version_id = '1';


CREATE SEQUENCE  SEQ_search MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1  NOCYCLE;
CREATE TABLE table_search (
  search_id NUMBER(10,0) NOT NULL,
  search_name VARCHAR2(128 CHAR) NOT NULL,
  type NUMBER(3,0) NOT NULL,
  search_data CLOB);
ALTER TABLE table_search ADD CONSTRAINT PRIMARY_86 PRIMARY KEY (
  search_id) ENABLE;
GRANT SELECT, INSERT, DELETE, UPDATE, REFERENCES ON table_search TO PUBLIC;


CREATE TABLE table_search_cust_string (
  search_id NUMBER(10,0) NOT NULL,
  cust_string_id NUMBER(10,0) NOT NULL,
  value VARCHAR2(512 CHAR) NOT NULL);
CREATE UNIQUE INDEX search_cust_string_UK_1 ON table_search_cust_string (
  search_id,
  cust_string_id);
CREATE INDEX search_cust_string_IK_1 ON table_search_cust_string (
  search_id);
CREATE INDEX search_cust_string_IK_2 ON table_search_cust_string (
  cust_string_id);
GRANT SELECT, INSERT, DELETE, UPDATE, REFERENCES ON table_search_cust_string TO PUBLIC;
ALTER TABLE table_search_cust_string ADD CONSTRAINT table_search_cust_str_ibfk_1 FOREIGN KEY (search_id) REFERENCES table_search (search_id) ON DELETE CASCADE ENABLE;
ALTER TABLE table_search_cust_string ADD CONSTRAINT table_search_cust_str_ibfk_2 FOREIGN KEY (cust_string_id) REFERENCES table_cust_string (cust_string_id) ON DELETE CASCADE ENABLE;


CREATE TABLE table_search_cust_integer (
  search_id NUMBER(10,0) NOT NULL,
  cust_integer_id NUMBER(10,0) NOT NULL,
  value NUMBER(10,0) NOT NULL);
CREATE UNIQUE INDEX search_cust_integer_UK_1 ON table_search_cust_integer (
  search_id,
  cust_integer_id);
CREATE INDEX search_cust_integer_IK_1 ON table_search_cust_integer (
  search_id);
CREATE INDEX search_cust_integer_IK_2 ON table_search_cust_integer (
  cust_integer_id);
GRANT SELECT, INSERT, DELETE, UPDATE, REFERENCES ON table_search_cust_integer TO PUBLIC;
ALTER TABLE table_search_cust_integer ADD CONSTRAINT table_search_cust_int_ibfk_1 FOREIGN KEY (search_id) REFERENCES table_search (search_id) ON DELETE CASCADE ENABLE;
ALTER TABLE table_search_cust_integer ADD CONSTRAINT table_search_cust_int_ibfk_2 FOREIGN KEY (cust_integer_id) REFERENCES table_cust_integer (cust_integer_id) ON DELETE CASCADE ENABLE;


CREATE TABLE table_search_cust_boolean (
  search_id NUMBER(10,0) NOT NULL,
  cust_boolean_id NUMBER(10,0) NOT NULL,
  value NUMBER(3,0) NOT NULL);
CREATE UNIQUE INDEX search_cust_boolean_UK_1 ON table_search_cust_boolean (
  search_id,
  cust_boolean_id);
CREATE INDEX search_cust_boolean_IK_1 ON table_search_cust_boolean (
  search_id);
CREATE INDEX search_cust_boolean_IK_2 ON table_search_cust_boolean (
  cust_boolean_id);
GRANT SELECT, INSERT, DELETE, UPDATE, REFERENCES ON table_search_cust_boolean TO PUBLIC;
ALTER TABLE table_search_cust_boolean ADD CONSTRAINT table_search_cust_bool_ibfk_1 FOREIGN KEY (search_id) REFERENCES table_search (search_id) ON DELETE CASCADE ENABLE;
ALTER TABLE table_search_cust_boolean ADD CONSTRAINT table_search_cust_bool_ibfk_2 FOREIGN KEY (cust_boolean_id) REFERENCES table_cust_boolean (cust_boolean_id) ON DELETE CASCADE ENABLE;


CREATE TABLE table_search_cust_html (
  search_id NUMBER(10,0) NOT NULL,
  cust_html_id NUMBER(10,0) NOT NULL,
  value CLOB);
CREATE UNIQUE INDEX search_cust_html_UK_1 ON table_search_cust_html (
  search_id,
  cust_html_id);
CREATE INDEX search_cust_html_IK_1 ON table_search_cust_html (
  search_id);
CREATE INDEX search_cust_html_IK_2 ON table_search_cust_html (
  cust_html_id);
GRANT SELECT, INSERT, DELETE, UPDATE, REFERENCES ON table_search_cust_html TO PUBLIC;
ALTER TABLE table_search_cust_html ADD CONSTRAINT table_search_cust_html_ibfk_1 FOREIGN KEY (search_id) REFERENCES table_search (search_id) ON DELETE CASCADE ENABLE;
ALTER TABLE table_search_cust_html ADD CONSTRAINT table_search_cust_html_ibfk_2 FOREIGN KEY (cust_html_id) REFERENCES table_cust_html (cust_html_id) ON DELETE CASCADE ENABLE;


CREATE TABLE table_search_cust_choice (
  search_id NUMBER(10,0) NOT NULL,
  cust_choice_id NUMBER(10,0) NOT NULL,
  value VARCHAR2(64 CHAR) NOT NULL);
CREATE UNIQUE INDEX search_cust_choice_UK_1 ON table_search_cust_choice (
  search_id,
  cust_choice_id);
CREATE INDEX search_cust_choice_IK_1 ON table_search_cust_choice (
  search_id);
CREATE INDEX search_cust_choice_IK_2 ON table_search_cust_choice (
  cust_choice_id);
GRANT SELECT, INSERT, DELETE, UPDATE, REFERENCES ON table_search_cust_choice TO PUBLIC;
ALTER TABLE table_search_cust_choice ADD CONSTRAINT table_search_cust_chce_ibfk_1 FOREIGN KEY (search_id) REFERENCES table_search (search_id) ON DELETE CASCADE ENABLE;
ALTER TABLE table_search_cust_choice ADD CONSTRAINT table_search_cust_chce_ibfk_2 FOREIGN KEY (cust_choice_id) REFERENCES table_cust_choice (cust_choice_id) ON DELETE CASCADE ENABLE;


ALTER TABLE table_sess ADD pick NUMBER(3,0) DEFAULT '1' NOT NULL;
ALTER TABLE table_sch ADD  pick NUMBER(3,0) DEFAULT '1' NOT NULL;

	
MERGE INTO table_weekend ttarget
USING (
	SELECT 'SE' AS cid, '1,7' AS cdy
	FROM DUAL
	) tsource
ON (tsource.cid = ttarget.country_id 
    AND tsource.cdy = ttarget.days)
WHEN NOT MATCHED THEN 	
	INSERT (country_id, days) VALUES ('SE', '1,7');

	
	
CREATE OR REPLACE TRIGGER TRIG_search BEFORE INSERT OR UPDATE ON table_search FOR EACH ROW
DECLARE 
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
  IF INSERTING AND :new.search_id IS NULL THEN
    SELECT  SEQ_search.NEXTVAL INTO v_newVal FROM DUAL;
    IF v_newVal = 1 THEN 
      SELECT NVL(max(search_id),0) INTO v_newVal FROM table_search;
      v_newVal := v_newVal + 1;
      LOOP
           EXIT WHEN v_incval>=v_newVal;
           SELECT SEQ_search.nextval INTO v_incval FROM dual;
      END LOOP;
    END IF;
   :new.search_id := v_newVal;
  END IF;
END;
/

DISCONNECT;
exit;
