<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output method="html" indent="yes" encoding="UTF-8"/>

  <xsl:include href="#export_absolute_path#xsl/lib.xslt"/>
  <xsl:include href="#export_absolute_path#xsl/testplanHTML_Lib.xslt"/>
  <xsl:template match="/">

    <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

	  <head>		
		<title>XStudio Report</title>
		<meta name="description" content="XStudio"/>
		<meta name="keywords" content="xstudio, report"/>
		<meta name="author" lang="en" content="XQual"/>
		<meta name="robots" content="noarchive"/>
		<meta http-equiv="Pragma" content="no-cache"/>
	  	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
		<meta http-equiv="Content-Language" content="en"/>		
		<link rel="stylesheet" href="#css#" type="text/css"/>		
	  </head>

      <body>
        <xsl:variable name="nbCategory"            select="count(testplans/category)" />
        <xsl:variable name="domain"                select="testplans/@domain" />
        <xsl:variable name="graphInReportsEnabled" select="testplans/@graphInReportsEnabled" />
        <xsl:variable name="documentDate"          select="testplans/@date" />
        <xsl:variable name="documentAuthor"        select="testplans/@author" />

        <div align="center">
          <table width="100%">
            <tr>
              <td valign="top"><img src="#images#/#company_logo#"/></td>
            </tr>
          </table>
          <br/>

          <xsl:if test="$domain = 1">
             <span class="report_title">#testplan.Complete_Testplan#</span><br/>
          </xsl:if>
          <xsl:if test="$domain = 2">
            <span class="report_title">#testplan.Category_Testplan#</span><br/>
          </xsl:if>
          <xsl:if test="$domain = 3">
            <span class="report_title">#testplan.Folder_Testplan#</span><br/>
          </xsl:if>
          <xsl:if test="$domain = 4">
            <span class="report_title">#testplan.Campaign_Testplan#</span><br/>
          </xsl:if>

          <span class="report_title"><b>&lt;&lt;&lt; Feature &gt;&gt;&gt;</b></span><br/>
          <span class="report_title">&lt;&lt;&lt; &gt;&gt;&gt; Product Line</span><br/>
        </div>
        <br/><br/><br/><br/>
        
        <h1>Table of contents</h1>
        <br/><br/><br/>

        <h1>Change history</h1>
        <!-- Change History -->
        <table width="100%">
          <tr>
            <td class="table_data_header">Revision</td>
            <td class="table_data_header">Date</td>
            <td class="table_data_header">Author</td>
            <td class="table_data_header">Description</td>
          </tr>
          <tr>
            <td class="table_data_content">&#160;</td>
            <td class="table_data_content"></td>
            <td class="table_data_content"></td>
            <td class="table_data_content"></td>
          </tr>
          <tr>
            <td class="table_data_content">&#160;</td>
            <td class="table_data_content"></td>
            <td class="table_data_content"></td>
            <td class="table_data_content"></td>
          </tr>
          <tr>            
            <td class="table_data_content"></td>
            <td class="table_data_content"><xsl:value-of select="$documentDate" /></td>
            <td class="table_data_content"><xsl:value-of select="$documentAuthor" /></td>
            <td class="table_data_content"></td>
          </tr>
        </table>
        <br/><br/><br/>
        
        <xsl:call-template name="generateTBD"/>
        <br/><br/><br/>
       
        <xsl:call-template name="generateABBR"/>
        <br/><br/><br/>
                     
        <a name="_details"/>
        <h1>#testplan.Details#</h1>
        
        
        <xsl:if test="$domain = 4"> <!-- campaign testplan -->
          <xsl:variable name="campaignName"        select="testplans/campaign/@name" />
          <xsl:variable name="campaignDescription" select="testplans/campaign/description" />

          <h2>
            <img src="#images#/IconCampaign.gif"/>&#160;
            Campaign: <xsl:value-of disable-output-escaping="yes" select="$campaignName" />&#160;
          </h2>
          <!-- folder description -->
          <xsl:if test="string-length($campaignDescription)>0">
            <p><xsl:value-of disable-output-escaping="yes" select="$campaignDescription" /></p>
          </xsl:if>
        </xsl:if>
        
        <!-- ******************* TESTPLAN DETAILS *************************** -->
        <xsl:if test="$nbCategory > 0">
          <xsl:for-each select="testplans/category[count(descendant-or-self::test)>0]">
            <xsl:variable name="categoryName" select="@name" />
            
            <!-- Categories -->
            <a>
              <xsl:attribute name="name">
                <xsl:call-template name="generateUniqueId">
                  <xsl:with-param name="type" select="'category'"/>
                  <xsl:with-param name="id" select="@id"/>
                </xsl:call-template>
              </xsl:attribute>
            </a>
            <h2>
              <img src="#images#/IconCategory.gif"/>&#160;
              Category: <xsl:value-of disable-output-escaping="yes" select="$categoryName" />&#160;
            </h2>

            <!-- Attachments -->
            <xsl:call-template name="generateAttachments">
              <xsl:with-param name="parentType"     select="'CT_'"/>
              <xsl:with-param name="attachmentIcon" select="'#images#/IconAttachment.gif'"/>
            </xsl:call-template>

            <!-- Tests -->
            <xsl:for-each select="folder[count(descendant::test) > 0]"> <!-- recursive call to display folders -->
                <xsl:call-template name="generateDetailsFolder">
                  <xsl:with-param name="parentName" select="$categoryName"/>
                </xsl:call-template>
            </xsl:for-each>

          </xsl:for-each>
        </xsl:if>
        <xsl:if test="$nbCategory = 0">
          <!-- Folders -->
          <xsl:for-each select="testplans/folder[count(descendant::test) > 0]"> <!-- recursive call to display folders -->
              <xsl:call-template name="generateDetailsFolder">
                <xsl:with-param name="parentName" select="''"/>
              </xsl:call-template>
          </xsl:for-each>
        </xsl:if>          
      </body>
    </html>

  </xsl:template>


  <xsl:template name="generateDetailsFolder">
    <xsl:param name="parentName"/>

    <xsl:variable name="folderName" select="@name" />
    <xsl:variable name="folderDescription" select="description" />

    <xsl:if test="count(test) > 0">
      <h3>Reference: <xsl:value-of select="concat($parentName, '/', $folderName)" /></h3>

      <!-- folder description -->
      <p><xsl:value-of disable-output-escaping="yes" select="$folderDescription" /></p>

      <xsl:call-template name="generateAttachments">
        <xsl:with-param name="parentType" select="'FL_'"/>
        <xsl:with-param name="attachmentIcon" select="'#images#/IconAttachment.gif'"/>
      </xsl:call-template>

      <xsl:call-template name="generateBasicTestsDetailsFromCurrentLevel"/>
    </xsl:if>

    <!-- Recursivity -->
    <xsl:for-each select="folder">
      <xsl:if test="count(descendant::test) > 0">
        <xsl:call-template name="generateDetailsFolder">
          <xsl:with-param name="parentName" select="concat($parentName, '/', $folderName)"/>
        </xsl:call-template>
      </xsl:if>
    </xsl:for-each>
  </xsl:template>

  <xsl:template name="generateFolderDetails">
    <xsl:variable name="nbTests"            select="count(descendant-or-self::test)"/>
    <xsl:variable name="nbTestcases"        select="count(descendant-or-self::testcase)"/>
    <xsl:variable name="nbTestcasesNotImpl" select="count(descendant-or-self::testcase[@devCompleted='0'])"/>
    <xsl:variable name="nbTestcasesImpl"    select="count(descendant-or-self::testcase[@devCompleted='1'])"/>
    <xsl:variable name="completion"         select="format-number(100 * $nbTestcasesImpl div $nbTestcases, '##.##')"/>

    <xsl:if test="$nbTests != 0">
      <td class="table_data_content"><xsl:value-of disable-output-escaping="yes" select="$nbTests"/></td>
    </xsl:if>
    <xsl:if test="$nbTests = 0">
      <td class="table_data_content"></td>
    </xsl:if>

    <xsl:if test="$nbTestcases != 0">
      <td class="table_data_content"><xsl:value-of disable-output-escaping="yes" select="$nbTestcases"/></td>
      <xsl:if test="$nbTestcasesNotImpl != 0">
        <td class="table_data_content_red"><xsl:value-of disable-output-escaping="yes" select="$nbTestcasesNotImpl"/></td>
      </xsl:if>
      <xsl:if test="$nbTestcasesNotImpl = 0">
        <td class="table_data_content_red">&#160;</td>
      </xsl:if>
      <xsl:if test="$nbTestcasesImpl != 0">
        <td class="table_data_content_green"><xsl:value-of disable-output-escaping="yes" select="$nbTestcasesImpl"/></td>
      </xsl:if>
      <xsl:if test="$nbTestcasesImpl = 0">
        <td class="table_data_content_green">&#160;</td>
      </xsl:if>
      <xsl:if test="$completion != 0">
        <td class="table_data_content"><xsl:value-of disable-output-escaping="yes" select="concat($completion, ' %')"/></td>
      </xsl:if>
      <xsl:if test="$completion = 0">
        <td class="table_data_content">&#160;</td>
      </xsl:if>
    </xsl:if>
    <xsl:if test="$nbTestcases = 0">
      <td class="table_data_content">&#160;</td>
      <td class="table_data_content">&#160;</td>
      <td class="table_data_content">&#160;</td>
      <td class="table_data_content">&#160;</td>
    </xsl:if>
  </xsl:template>









  <xsl:template name="generateBasicTestsDetailsFromCurrentLevel">
    <xsl:call-template name="generateBasicTestsDetails">
      <xsl:with-param name="nodeSet" select="test"/>
    </xsl:call-template>
  </xsl:template>

  <xsl:template name="generateBasicTestsDetails">
    <xsl:param name="nodeSet"/>

    <xsl:for-each select="$nodeSet">
      <xsl:call-template name="generateBasicTestDetails"/>
    </xsl:for-each>
  </xsl:template>

  <xsl:template name="generateBasicTestDetails">
    <xsl:variable name="testName"          select="@name" />
    <xsl:variable name="testId"            select="@id" />
    <xsl:variable name="author"            select="@author" />
    <xsl:variable name="developer"         select="@developer" />
    <xsl:variable name="testDescription"   select="description" />
    <xsl:variable name="testPrerequisites" select="prerequisites" />
    <xsl:variable name="nbTestcases"       select="count(testcase)" />

    <br/>
    <a>
      <xsl:attribute name="name">
        <xsl:call-template name="generateUniqueId">
          <xsl:with-param name="type" select="'test'"/>
          <xsl:with-param name="id" select="@id"/>
        </xsl:call-template>
      </xsl:attribute>
    </a>

    <table width="100%">
      <tr>
        <td class="table_data_subheader_bottom_align">
          <h4 class="no_margin">
            <img src="resources/images/IconTest.gif"/>&#160;
            [Test_<xsl:value-of select="$testId"/>]&#160;<xsl:value-of select="$testName" />
          </h4>
        </td>
        <td class="table_data_subheader_bottom_align">
          <b>#testplan.Author#: </b> <xsl:value-of disable-output-escaping="yes" select="$author" />
          &#160;&#160;&#160;&#160;&#160;&#160;
          <b>#testplan.Developer#: </b> <xsl:value-of disable-output-escaping="yes" select="$developer" />
          &#160;&#160;&#160;&#160;&#160;&#160; Pass/Fail:  _________________
        </td>
      </tr>
      
      
      <!-- test description is mandatory so displayed even if empty -->
      <tr><td colspan="2" class="table_data_subsubsubheader">#testplan.Description#</td></tr>
      <tr>
      	<td colspan="2" class="table_data_content">
           <xsl:call-template name="generateAttachments">
              <xsl:with-param name="parentType" select="'T_'"/>
              <xsl:with-param name="attachmentIcon" select="'resources/images/IconAttachment.gif'"/>
           </xsl:call-template>
      	   <xsl:value-of disable-output-escaping="yes" select="$testDescription" />
      	   &#160; <!-- to avoid having a ugly effect when there is no description -->
      	</td>
      </tr>
      
      <xsl:if test="string-length($testPrerequisites)>0">
        <tr><td colspan="2" class="table_data_subsubsubheader">#testplan.Prerequisites#</td></tr>
        <tr>
          <td colspan="2" class="table_data_content">
            <xsl:value-of disable-output-escaping="yes" select="$testPrerequisites" />
          </td>
        </tr>
      </xsl:if>

      <xsl:if test="count(requirement)>0">
        <tr><td colspan="2" class="table_data_subsubsubheader">#testplan.Requirements#</td></tr>
        <xsl:for-each select="requirement">
          <xsl:variable name="reqName"          select="@name" />
          <xsl:variable name="reqId"            select="@id" />
          <xsl:variable name="reqDescription"   select="description" />
          <tr>
            <td class="table_data_content">
              <xsl:value-of disable-output-escaping="yes" select="$reqId" />&#160; &#160; &#160;<xsl:value-of disable-output-escaping="yes" select="$reqName" />
            </td>
            <td class="table_data_content"><xsl:value-of disable-output-escaping="yes" select="$reqDescription" /></td>
          </tr>
        </xsl:for-each>
      </xsl:if>


      <xsl:if test="count(specification)>0">
        <tr><td colspan="2" class="table_data_subsubsubheader">#testplan.Specifications#</td></tr>
        <xsl:for-each select="specification">
          <xsl:variable name="specName"          select="@name" />
          <xsl:variable name="specId"            select="@id" />
          <xsl:variable name="specDescription"   select="description" />
          <tr>
            <td class="table_data_content">
              <xsl:value-of disable-output-escaping="yes" select="$specId" />&#160; &#160; &#160;<xsl:value-of disable-output-escaping="yes" select="$specName" />
            </td>
            <td class="table_data_content"><xsl:value-of disable-output-escaping="yes" select="$specDescription" /></td>
          </tr>
        </xsl:for-each>
      </xsl:if>
      
    </table>
    <br/>
    <br/>
    <br/>

    <xsl:if test="$nbTestcases>0">
      <xsl:for-each select="testcase">
        <xsl:sort select="@index" data-type="number"/>

        <xsl:variable name="testcaseId"                select="@id" />
        <xsl:variable name="testcaseName"              select="@name" />
        <xsl:variable name="testcaseIndex"             select="@index" />
        <xsl:variable name="testcaseImplemented"       select="@devCompleted" />
        <xsl:variable name="testcaseUseDescAsTestplan" select="@useDescAsTestplan" />
        <xsl:variable name="testcaseDescription"       select="description" />
        <xsl:variable name="nbStep"                    select="count(steps/object[@type='root']/object[@type='step'])" />
        <xsl:variable name="nbAttachment"              select="count(attachment)" />

        <!--
        table:        border missing
        margin:       overwrite the right border in Word
        padding:      no effect on Word
        margin in %:  no effect on Word
        margin-right: no effect on Word
        -->
        <!-- <div style="margin-left:50px"> -->
        <table border="0" width="100%"><tr><td width="10%">&#160;&#160;</td><td class="table_container" width="90%">
        <table border="0" width="100%">
          <tr>
            <td class="table_data_subsubheader_bottom_align" colspan="2">

              <h5 class="no_margin">
                <img src="resources/images/IconTestcase.gif"/>
                <xsl:if test="$testcaseImplemented='1'">
                  <img src="resources/images/IconImplemented.gif"/>
                </xsl:if>
                <xsl:if test="$testcaseImplemented='0'">
                  <img src="resources/images/IconNotImplemented.gif"/>
                </xsl:if>
                [Test case_<xsl:value-of select="$testcaseId"/>] (<xsl:value-of select="$testcaseIndex"/>)
                <b>&#160;&#160;&#160;<xsl:value-of select="$testcaseName"/></b>
              </h5>
              
            </td>
            <td with="40%" class="table_data_subsubheader_bottom_align" valign="bottom">Pass/Fail:  _________________</td>
          </tr>
          
          <xsl:if test="string-length($testcaseDescription)>0 or $nbAttachment>0">
            <tr>
              <td class="table_data_subsubsubheader" colspan="3">#testplan.Description#</td>
            </tr>
            <tr>
              <td  class="table_data_content2" colspan="3">
                <xsl:call-template name="generateAttachments">
                    <xsl:with-param name="parentType" select="'TC_'"/>
                    <xsl:with-param name="attachmentIcon" select="'resources/images/IconAttachment.gif'"/>
                </xsl:call-template>
                <xsl:value-of disable-output-escaping="yes" select="$testcaseDescription"/>
              </td>
            </tr>
          </xsl:if>

          <!-- steps -->
          <xsl:if test="$nbStep > 0">
            <tr>
              <td class="table_data_subsubsubheader">#testplan.Step#</td>
              <td class="table_data_subsubsubheader">#testplan.Parameters#</td>
              <td class="table_data_subsubsubheader">#testplan.ExpectedResult#</td>
            </tr>
            <xsl:for-each select="steps/object[@type='root']/object[@type='step']">
              <xsl:variable name="nbParameters" select="count(object[@type='parameters']/object[@type='parameter'])" />

              <tr>
                <!-- all the other lines: we add the description, parameters and checks -->
                <td class="table_data_content"><xsl:value-of select="@description" /></td>
                <td class="table_data_content">
                  <xsl:if test="$nbParameters = 0">
                    &#160;
                  </xsl:if>
                  <xsl:for-each select="object[@type='parameters']/object[@type='parameter']">
                    - <xsl:value-of select="@description" /><br/>
                  </xsl:for-each>
                </td>
                <td class="table_data_content">
                  <table>
                    <xsl:for-each select="object[@type='checks']/object[@type='operator']">
                      <xsl:call-template name="generateChecksDetails">
                        <xsl:with-param name="tab" select="''"/>
                      </xsl:call-template>
                    </xsl:for-each>
                  </table>
                </td>
              </tr>
            </xsl:for-each>
          </xsl:if>
          
        </table>
        </td></tr></table>
        <br/>
        <br/>    
        <br/>
      </xsl:for-each>
      
    </xsl:if>
  </xsl:template>
  
  
  
</xsl:stylesheet>