<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output method="html" indent="yes" encoding="UTF-8"/>

  <!-- global variables -->
  <xsl:variable name="codebase" select="properties/@codebase" />

  <xsl:include href="#export_absolute_path#xsl/email_Lib.xslt"/>
  <xsl:template match="/">
    <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

	  <head>		
		<title>XStudio Report</title>
		<meta http-equiv="Pragma" content="no-cache"/>
	  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
		<meta http-equiv="Content-Language" content="en"/>
	   <style TYPE="text/css">
	     BODY {background: white; color: black; font-size: 10pt; font-family: "Century Gothic", Helvetica, Arial, sans-serif;}
	     H1 {margin-top:10pt; margin-bottom:2pt; padding-left:0pt; font-weight:bold; font-size:12pt; color:#d66d18}
	     H2 {margin-top:10pt; margin-bottom:2pt; padding-left:0pt; font-weight:bold; font-size:10pt; color:#d66d18}
	     H3 {margin-top:10pt; margin-bottom:2pt; padding-left:0pt; font-weight:bold; font-size:8pt; color:#358560}
	     TABLE {border-style:solid; border-width:1px; border-color:#96d6b9; border-collapse:collapse}
	     TD {font-size:8pt}
	     A:link {font-weight:bold;  font-size:8pt;  text-decoration:none;  background-color:transparent;  color:#518b72}
	     A:visited {font-weight:bold;  font-size:8pt;  text-decoration:none;  background-repeat:no-repeat;  background-color:transparent;  color:#518b72}
	     A:active {font-weight:bold;  font-size:8pt;  text-decoration:none;  background-color:transparent;  color:#518b72}
	     A:hover {font-weight:bold;  font-size:8pt;  text-decoration:none;  background-color:transparent;  color:#ff9535}
	     .text_box {border-style:solid; border-width:1px; border-color:#96d6b9; border-collapse:collapse; font-size:8pt; margin:0; padding:4px; background-color:#def2e9; color:#000000; vertical-align:top}
	     .table_data_header {font-weight:bold; font-size:8pt; border-spacing:0px; padding:4px; background-color:#def2e9; color:#000000; vertical-align:top}
	     .table_data_subheader {font-weight:bold; font-size:8pt; border-spacing:0px; padding:4px; background-color:#def2e9; color:#000000; vertical-align:top}
	     .table_data_content {font-weight:normal; font-size:8pt; border-spacing:0px; padding:4px; background-color:#def2e9; color:#000000; vertical-align:top}
	     .text_red    {color:#cc0000}
       .text_orange {color:#ff7f01}
       .text_blue   {color:#0000cc}
       .text_green  {color:#00aa00}
       .text_grey   {color:#666666}
	   </style>
	  </head>
    
      <body>
        <img border="0" src="http://www.xqual.com/resources/images/xqual_thumbnail.gif"/>
        
        <h1>Defect Creation</h1>
        <xsl:variable name="defectId" select="properties/id" />
        <xsl:variable name="defectName" select="properties/name" />
        The defect <b>[<xsl:value-of select="$defectId"/>] <xsl:value-of select="$defectName"/></b> was created on the <b><i><xsl:value-of select="properties/date"/></i></b><br/>
        Url:
        <xsl:call-template name="urlToObject">
          <xsl:with-param name="globalId" select="$defectId"/>
          <xsl:with-param name="name"     select="$defectName"/> 
        </xsl:call-template>
        <br/><br/>
        
        <h2>Details</h2>
        <table>
          <tr><td width="100px" class="table_data_subheader">Status:</td><td width="200px" class="table_data_content"><b><u><xsl:call-template name="defectStatusToString"><xsl:with-param name="status" select="properties/status"/></xsl:call-template></u></b></td></tr>
          <tr><td class="table_data_subheader">Severity:</td><td class="table_data_content"><xsl:call-template name="defectSeverityToString"><xsl:with-param name="severity" select="properties/severity"/></xsl:call-template></td></tr>
          <tr><td class="table_data_subheader">Priority:</td><td class="table_data_content"><xsl:call-template name="defectPriorityToString"><xsl:with-param name="priority" select="properties/priority"/></xsl:call-template></td></tr>
          <tr><td class="table_data_subheader">Platform:</td><td class="table_data_content"><xsl:value-of select="properties/platform"/></td></tr>
          <tr><td class="table_data_subheader">OS:</td><td class="table_data_content"><xsl:value-of select="properties/os"/></td></tr>
          <tr><td class="table_data_subheader">Reproducibility:</td><td class="table_data_content"><xsl:call-template name="defectReproducibilityToString"><xsl:with-param name="reproducibility" select="properties/reproducibility"/></xsl:call-template></td></tr>
          <tr><td class="table_data_subheader">Reporter:</td><td class="table_data_content"><xsl:value-of select="properties/reporter/@name"/></td></tr>
          <tr>
            <td class="table_data_subheader">Assigned to:</td><td class="table_data_content">
              <xsl:for-each select="properties/assignedTo">
                <xsl:value-of select="@name"/><br/>
              </xsl:for-each>
            </td>
          </tr>

          <!-- custom fields -->
          <xsl:call-template name="insertCustomFields"/>      
          
        </table>
        
        <h3>Description:</h3>
        <div class="text_box"><xsl:value-of disable-output-escaping="yes" select="properties/description"/>&#160;</div>
          
        <h3>Steps to reproduce:</h3>
        <div class="text_box"><xsl:value-of disable-output-escaping="yes" select="properties/stepsToReproduce"/>&#160;</div>
        
        <h3>Found in:</h3>
        <div class="text_box">
        	<xsl:for-each select="properties/foundIn">
        		[<xsl:value-of disable-output-escaping="yes" select="@id"/>]&#160;
        		<xsl:value-of disable-output-escaping="yes" select="@name"/>&#160;
        		<xsl:value-of disable-output-escaping="yes" select="@version"/><br/>
        	</xsl:for-each>
        </div>
        
        <br/><br/>
        <a href="http://www.xqual.com">http://www.xqual.com</a>
        <br/><br/><br/>
      </body>
    </html>

  </xsl:template>

</xsl:stylesheet>